=== debian/changelog ===
syslog-ng (3.27.1-3build1) groovy; urgency=medium

  * Rebuild against new json-c5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jul 2020 19:56:17 +0200

syslog-ng (3.27.1-3) unstable; urgency=medium

  * Fix sumologic.conf installation.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 16 Jun 2020 22:16:59 +0200

syslog-ng (3.27.1-2) unstable; urgency=medium

  * Fix self-tests as mod-snmptrapd-parser merged to mod-snmp package
    (closes: #962893).
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 16 Jun 2020 19:04:17 +0200

syslog-ng (3.27.1-1) unstable; urgency=medium

  * New upstream release:
    - builds with Bison 3.6.1 (closes: #960481).
  * Merge snmptrapd-parser mod to snmp mod.
  * Backport fix for hang on boot due to lack of entropy (closes: #913754).
  * Remove merged in patches.
  * Update configuration version.

  [ Balazs Scheidler <bazsi77@gmail.com> ]
  * Add support for the snmp() destination (syslog-ng-mod-snmp package).
  * Move the http() destination into a separate package (syslog-ng-mod-http).
  * Move BSD process accounting (pacct) support into the core package.
  * Move tags-parser() to the core package.
  * Add support for librdkafka based kafka destination (in mod-rdkafka
    package).
  * Use upstream scl.conf .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 17 May 2020 14:41:30 +0200
